using System;
using System.IO;
using Avalonia;
using Avalonia.Platform;
using Newtonsoft.Json;

namespace Ocarina2.Models;

public class Language
{
    public string Code;
    public readonly string MenuFile;
    public readonly string MenuOpen;
    public readonly string MenuExit;
    public readonly string Music;
    public readonly string NoMusic;
    public readonly string RPSong;
    public readonly string RPArtist;
    public readonly string RPIconText;

    public Language(string code, string menuFile, string menuOpen, string menuExit, string music, string noMusic, string rpSong, string rpArtist, string rpIconText)
    {
        Code = code;
        MenuFile = menuFile;
        MenuOpen = menuOpen;
        MenuExit = menuExit;
        Music = music;
        NoMusic = noMusic;
        RPSong = rpSong;
        RPArtist = rpArtist;
        RPIconText = rpIconText;
    }

    public static Language Load(string code)
    {
        var assets = AvaloniaLocator.Current.GetService<IAssetLoader>();
        using var stream = assets?.Open(new Uri($"avares://Ocarina2/Assets/Languages/{code}.json"));
        if (stream == null) throw new Exception("Could not load language strings");
        using var reader = new StreamReader(stream);
        return JsonConvert.DeserializeObject<Language>(reader.ReadToEnd())!;
    }
}